import QtQuick 1.1
import com.nokia.meego 1.0

import "contacts.js" as ContactsManager


Page {
    id: contactsContainer
   // tools: commonTools
    //width: parent.width
    //anchors.fill: parent
      Component.onCompleted: {
                ContactsManager.populateContacts();
           // contactsContainer.newMessage({data:"Hi","user_id":"201006960035"})
     }

      property alias indicator_state:wa_notifier.state

      State {
          name: "syncing"
          PropertyChanges {
              target: sync_window
              visible:true
              opacity:1;

          }
      }

      Rectangle{

          id:sync_window
          anchors.fill: parent
          z:1
          visible:false;
          opacity: 0

          ProgressBar{
              indeterminate: true
              visible:true;

          }

      }

    // signal conversationUpdated(int msgId, int msgType, string user_id,string lastMsg,string time,string formattedDate);
     signal conversationUpdated(variant message);
     signal sendMessage(string user_id, string message);
     signal sendTyping(string user_id);
     signal sendPaused(string user_id);


     function updateMessageStatus(msgKey,status)
     {

     }

     function openChatWindow(user_id)
     {

         //var chatWindow = ContactsManager.openChatWindow(user_id,"contacts")
          var chatWindow = getChatWindow(user_id);
          appWindow.pageStack.push(chatWindow.conversation);
          appWindow.requestPresence(user_id);
          return chatWindow

     }

    function onMessageSent(message){

          var chatWindow = getChatWindow(message.Contact.jid);
          if(chatWindow)chatWindow.conversation.messageSent(message.id);
    }

    function onMessageDelivered(message){
          var chatWindow = getChatWindow(message.Contact.jid);
          if(chatWindow)chatWindow.conversation.messageDelivered(message.id);
    }

    function updatePresence(user_id,presence)
    {
        console.log("update presence in QML, IMPLEMENT ME");
    }

     function pushContacts(contacts)
     {
        //console.log("AHOM"+contacts)

        ContactsManager.contacts=contacts;

        ContactsManager.populateContacts();
     }

      function getChatWindow(user_id)
      {

          var chatWindow = ContactsManager.getChatWindow(user_id);
          if(chatWindow == 0)
          {
              console.log("couldn't find chat window")
              var contactData = ContactsManager.getContactData(user_id)

              chatWindow = ContactsManager.createChatWindow(user_id, contactData.name,contactData.picture);

          }

          console.log("found chat window")
          console.log(user_id)
          console.log(chatWindow.conversation.user_id);

          return chatWindow;
      }

      function onAvailable(user_id){
          var chatWindow = getChatWindow(user_id);
          chatWindow.conversation.setOnline();
      }

      function onUnavailable(user_id,seconds){
          var chatWindow = getChatWindow(user_id);

          if(seconds)
              chatWindow.conversation.setOffline(seconds);
          else
              chatWindow.conversation.setOffline();

      }

      function onTyping(user_id){
          var chatWindow = getChatWindow(user_id);
          chatWindow.conversation.setTyping();

      }

      function onPaused(user_id){
          var chatWindow = getChatWindow(user_id);
          chatWindow.conversation.setPaused();
      }

     function addMessage(user_id,messages){

          var chatWindow = getChatWindow(user_id);


          for (var i =0; i< messages.length; i++)
          {
              chatWindow.conversation.newMessage(messages[i])
          }


      }

    function newMessage(msg_data){

        var chatWindow = getChatWindow(msg_data.user_id);
        chatWindow.conversation.newMessage(msg_data);
    }

    ListModel{

        id:contactsModel


    }

    Component{
        id:myDelegate
        Contact{

            jid:model.jid
            number:model.number
            picture:model.picture
            name:model.name;
            status:model.status

            //onClicked: {ContactsManager.openChatWindow(model.number,"contacts");contactsContainer.parent.parent.state="conversation"}
            onClicked: {openChatWindow(model.jid)}
        }
    }
    Component {
           id: sectionHeading
           Rectangle {
               width: parent.width
               height: 70
              // color: "#e6e6e6"
               color:"transparent"
               Text {
                   text: section
                   font.pixelSize: 60
                   font.bold: true
                   color:"#27a01b"
                   anchors.verticalCenter: parent.verticalCenter
                   horizontalAlignment: Text.AlignRight
                   width:parent.width-5
               }
           }
       }
    Column{
        anchors.fill: parent;
        spacing:1
        width:parent.width
        height:parent.height
        WANotify{
            id:wa_notifier
        }

        ListView {

            id: list_view1
            //anchors.fill: parent
            width:parent.width
            height:parent.height-wa_notifier.height
            clip: true
            model: contactsModel
            delegate: myDelegate
            spacing: 1
            section.property: "alphabet"
            section.criteria: ViewSection.FullString
            section.delegate: sectionHeading

        }
    }


    SectionScroller{
        listView: list_view1
    }



}
