import QtQuick 1.1
import com.nokia.meego 1.0



import "conversations.js" as ConvScript

//import QtMobility.systeminfo 1.1
//import QtMobility.feedback 1.1
//import QtMultimediaKit 1.1

Page {
    id:conversation_view

    tools: ToolBarLayout{
                            id: commonTools
                            ToolIcon {
                                platformStyle: ToolButtonStyle{inverted:appWindow.stealth  || theme.inverted}
                                iconId: "toolbar-back";
                                onClicked: { appWindow.pageStack.pop(); } }
                           // ToolIcon { iconId: "toolbar-view-menu"; }
                    }

    property string user_id;
    property string user_name;
    property string user_picture;
    property string prev_state:"chats"
    property bool iamtyping:false


    Component.onCompleted:{
            console.log("opened chat window");
            requestPresence(user_id);

    }

    signal sendMessage(string user_id,string message);
   // signal conversationUpdated(int msgId, int msgType, string number,string lastMsg,string time,string formattedDate);
    signal conversationUpdated(variant message);
    signal typing(string user_id);
    signal paused(string user_id);

    function requestPresence()
    {
        appWindow.requestPresence(user_id);
    }

    function notifyReceived(){
        /*console.log('hello notify');
        //set volume

        devinfo.activeProfileDetails()

        var profile = devinfo.activeProfileDetails;

        console.log(profile.messageRingtoneVolume)
        console.log(profile.vibrationActive);

       /* snd_msg_received.volume = profile.messageRingtoneVolume()
        snd_msg_received.play();


        if(profile.vibrationActive())
            vibra_msg_received.start();*/
    }

    function updatePresence(presence){
        userstatus.state = presence == 1?"online":"";
    }

    function setOnline(){
        status.setOnline();
    }

    function setTyping(){
        status.setTyping();
    }

    function setPaused(){
        status.setPaused();
    }

    function setOffline(seconds){
        if(seconds)
            status.setOffline(seconds);
        else
            status.setOffline();
    }




    function getBubble(msg_id){

        for(var i =0; i < conv_data.count; i++){
            var bubble = conv_data.get(i);
            if(bubble.msg_id == msg_id)
                return bubble;
        }

        return 0;
    }

    function getBubbleIndex(msg_id){
        for(var i =0; i < conv_data.count; i++){
            var bubble = conv_data.get(i);
            if(bubble.msg_id == msg_id)
                return i;
        }

        return -1;
    }

    function messageSent(msg_id){


        var bubbleIndex = getBubbleIndex(msg_id);

        if(bubbleIndex > -1){
           // conv_items.view.model.setData(bubbleIndex,"state_status","pending");
            conv_data.setProperty(bubbleIndex,"status","pending");
        }
    }

    function messageDelivered(msg_id){

        var bubble = getBubble(msg_id);
        if(bubble){
            bubble.status= "delivered";
        }

    }


    function newMessage(message){
        //ConvScript.addMessage(message.id,message.content,message.type,message.formattedDate,message.timestamp,message.status);
        ConvScript.addMessage(message);

    }

    function getNameForBubble(uname)
    {
        var arr = uname.split(' ');
        return arr[0];
    }




    Rectangle{
        id:top_bar
        //onClicked: {conversation_view.visible=false;conversation_view.parent.parent.state=prev_state;}
        width:parent.width
        height:40;
        color:"transparent"


       UserStatus{
            id:status
            height:parent.height
            width:parent.width/2
            anchors.left: parent.left
            anchors.leftMargin: 5
            anchors.verticalCenter: parent.verticalCenter

        }

        Row{

            anchors.verticalCenter: parent.verticalCenter
            spacing:5
            width:(parent.width/2)-5
            anchors.right: parent.right
            anchors.rightMargin: 5

           Rectangle{
               id:userimage
               width:25
               height:25
               radius: 20

               Image{
                   anchors.fill: parent
                   source: user_picture

               }
           }
            Label {
                id: username
                text: user_name
                anchors.verticalCenter: parent.verticalCenter
                font.bold: true
            }


        }
    }

    ListModel{
        id: conv_data
    }

    Component{
        id:myDelegate

       SpeechBubble{
           message: model.message;
           date:model.timestamp
           from_me:model.type==1
           picture: user_picture
           name: getNameForBubble(user_name)
           state_status:model.status
       }
    }

    ListView{
        id:conv_items

        anchors.bottom: input_separator.top
        anchors.top: top_bar.bottom
        anchors.bottomMargin: 10
        anchors.topMargin: 5
        width:parent.width
        delegate: myDelegate
        model: conv_data
        spacing: 15
        clip: true

    }

    Separator{
        id:input_separator

        bottom_margin: 1
        top_margin: 0
        anchors.bottom: input_holder.top
        width:parent.width
        visible: !appWindow.stealth && !theme.inverted
    }

    Timer {
        id:typing_timer
        interval: 2000; running: false; repeat: false
        onTriggered: {
            console.log("STOPPED TYPING");
            iamtyping = false;
            paused(user_id);
            }
    }




    Row
    {
        id:input_holder
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 10
        anchors.right: parent.right
        anchors.left: parent.left
        anchors.rightMargin: 2
        anchors.leftMargin: 2
        spacing: 5
        opacity: appWindow.stealth?0.3:1


        TextArea{
            id:chat_text
            //width:parent.width
            width:parent.width-send_button.width-5


            onFocusChanged: {
                 conv_items.positionViewAtEnd()
            }

            onTextChanged: {

                if(!iamtyping)
                {
                    console.log("TYPING");
                    typing(user_id);
                }
                iamtyping = true;
                typing_timer.restart();

            }




        }



        /*DeviceInfo {
               id: devinfo;

           }


        HapticsEffect {
            id: vibra_msg_received
            attackIntensity: 0.0
            attackTime: 250
            intensity: 1.0
            duration: 500
            fadeTime: 250
            fadeIntensity: 0.0
        }

        //SoundEffect
        Audio{
               id: snd_msg_received

               source: "/usr/share/sounds/ring-tones/Message 1.mp3"
           }*/



        Button
        {
            id:send_button
            platformStyle:  ButtonStyle{
               inverted:appWindow.stealth  || theme.inverted
            }

            width:65
            ToolIcon{
                platformStyle: ToolItemStyle{inverted:appWindow.stealth  || theme.inverted}
                iconId: "toolbar-send-chat"
                anchors.centerIn: parent
                onClicked: parent.clicked();
            }

            anchors.bottom: parent.bottom
            onClicked:{

                 var toSend = chat_text.text.trim();
                 if ( toSend != "")
                 {

                        sendMessage(user_id,toSend);
                        chat_text.text = "";
                 }
                 chat_text.focus = true;

            }

                //{notifyReceived()}
        }

    }

}
